from StringIO import StringIO

# These are included in the file if missing.
DEFAULT_DECL = {
   '<!DOCTYPE':
   '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" ' \
   '"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">',

   '<?xml': '<?xml version="1.0" encoding="utf-8"?>'
   }

def prepare_xml(file):
    """Tidies up things within the zpts."""

    content = ''.join(file.readlines())

    for el in ['<!DOCTYPE', '<?xml']:
       idx = content.find(el)
       if idx >= 0:
          if content[0:idx].strip():
             idx2 = content.find('>', idx+1)
             extraction = content[idx:idx2+1]
             content = extraction + content[:idx] + content[idx2+1:]
             # mispositioned element fixed at this point
       else: # element was not found, replace with default
          content = DEFAULT_DECL[el] + content

    return StringIO(content.strip())


def make_lines(l, join=' ', max=70):
    lines = ['']
    for item in l:
        lastline = lines[-1] + str(item) + join
        if len(lastline) > 70 and lines[-1]:
            lines.append(str(item))
        else:
            lines[-1] += join + str(item)

    return lines

def quote(s):
    """Quote if string has spaces."""

    if [ch for ch in s if ch.isspace()]:
        return '"%s"' % s
    else:
        return s
