import sys
try:
    import gdchart
except ImportError:
    gdchart = None

def po_reverse_sort(x, y):
    if x[0] == y[0]:
        if x[1] >= y[1]:
            return 1
        else:
            return -1
    elif x[0] > y[0]:
        return -1
    else:
        return 1

def make_chart(pot, pos, out, size=(800, 500), **kwargs):
    if not gdchart:
        raise ImportError, 'No module named gdchart'

    msgids = pot.keys()
    total = len(msgids)
    names = [pot.mime_header['Language-Code']]
    values = [total]

    print "languages: %s, msgid's: %s" % (len(pos), len(msgids))
    for po in [p for p in pos if p.mime_header['Language-Code'] != 'en']:
        name = '%s' % po.mime_header['Language-Code']

        value = 0
        for msgid in msgids:
            if msgid in po and po[msgid][0]: # translated
                if not [1 for fuzzy in po[msgid][2] if 'fuzzy' in fuzzy]:
                    value += 1

        names.append(name)
        values.append(value)
        print "%s: %s missing (%.0f%% done)" % (name, total - value, value / (total*1.005) * 100)

    # sort by number of translated messages
    # keeping 'en' always on first position
    z = zip(values[1:], names[1:])
    z.sort(po_reverse_sort)
    values = values[0:1]
    names = names[0:1]
    for v,n in z:
        values.append(v)
        names.append(n)

    options = {'bg_color': 0xffffff,
               'border': gdchart.GDC_BORDER_ALL,
               'xaxis_font': gdchart.GDC_SMALL,
               'title': pot.mime_header['Project-Id-Version'],
               }
    options.update(kwargs)
    gdchart.option(**options)

    gdchart.chart(gdchart.GDC_BAR,
                  size,
                  out,
                  names,
                  values)
